/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.evasion.plugin.common;

import com.evasion.ejb.local.PersonManagerLocal;
import com.evasion.ejb.remote.PersonManagerRemote;
import com.evasion.entity.Civilite;
import com.evasion.entity.Individual;
import com.evasion.entity.Person;
import java.util.Date;
import javax.ejb.Local;
import javax.ejb.Remote;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;

/**
 *
 * @author sebastien.glon
 */
@Stateless
@Local(value = PersonManagerLocal.class)
@Remote(value = PersonManagerRemote.class)
public class PersonEJB implements PersonManagerLocal, PersonManagerRemote {

    @PersistenceContext(unitName = Constante.PERSISTENCE_UNIT)
    private EntityManager em;

    public PersonEJB() {
    }

    protected PersonEJB(EntityManager em) {
        this.em = em;
    }

    @Override
    public Long saveIndividual(Long id, Civilite civ, String nom, String prenom, Date naissance, String email) {
        Individual indiv;
        if (id == null) {
            indiv = new Individual(email, civ, nom, prenom, naissance);
            createPerson(indiv);
        } else {
            indiv = em.find(Individual.class, id);
            indiv.setTitre(civ);
            indiv.setNom(nom);
            indiv.setPrenom(prenom);
            indiv.setAnniversaire(naissance);
            indiv.setEmail(email);
            indiv = em.merge(indiv);
        }
        return indiv.getId();
    }

    public void saveCorporation(String nom, Byte logo, String email) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public Person createPerson(Person p) {
        em.persist(p);
        return p;
    }

    @Override
    public void deletePerson(Person p) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    @Override
    public Person updatePerson(Person p) {
        throw new UnsupportedOperationException("Not supported yet.");
    }
}
